<id>
Users Today for YaBB 2.7.00
</id>

<version>
1.4
</version>

<mod info>
**Original code and concept by Daicogra for YaBB 1.1.  Re-coding to work with YaBB 2.5 AE as well as "Enhancements" to this mod have been made by Brian Longo, Jeffrey Man and Detlef Pilzecker. Updated to 2.6.0/2.6.1/2.6.11/2.7.00 by Dandello

**Overview:

Daicoga's original version:
-- Count the number of members that visit your board on any given day.  At midnight, the counter is reset to zero.

Brian Longo's "enhancements":
-- Added the capability to count guests.  Counter for guests resets to zero at midnight.
-- Option to show or not show the number of guests along with the number of members in the Users Online Today box in Board Index.
-- Option to allow or disallow guests from seeing the Users Online Today box in Board Index.
-- Admin has the option of viewing the Guest IP Log in the Users Today section of the Admin Center below configuration box.
-- Admin has the option of enabling number of guests in Board Index as a link to go directly to the Users Today section of the Admin Center to view the Guest IP Log.
-- Admin can see user/guest stats for forum by day (log file).
-- Admin can view when most users/guests came to their board, as well as total number of users/guests and average users/guests per day.
-- Admin can choose to see log file for X days via an input value.
-- Admin can choose to use this as a "Log Only" mod where the Users Today block will not show up in the Board Index, yet still keep user/guest stats for the board.

Installation:
=============
1) Install using YabMod.

Note: 2.7.00 puts all the mod data files into 'Variables/Mods/utoday/' If you are in the process of converting an older YaBB forum and had this mod installed, place your Usertoday data files (guesttoday.txt, usertoday.txt, usrtodayconfig.txt, utstats.txt, uttotal.txt) into this folder.
</mod info>

<author>
Daicogra (1.1), Brian Longo (2.x), updated to 2.6.11/2.6.12/2.7.00 by Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com/cgi-bin/yabb2/YaBB.pl
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
if (@adminindexmods) {
</search for>

<add before>
push @adminindexmods, 'Users Today';
</add before>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
## Users Today Mod ##
    my $users_today = "userstoday|$mod_list{'userstoday_set'}|$mod_list{'userstoday_set1'}|";
    push @boardmod_mods, $users_today;
</add before>

<edit file>
YaBB.pl
</edit file>

<search for>
if (@yabbmods) {
</search for>

<add before>
push @yabbmods, 'Users Today';
</add before>

<search for>
banning();      # Check for banned people
</search for>

<add before>
if (-e("$vardir/usrtodayconfig.txt"))  { ## Users Today Mod ##
    require "$vardir/usrtodayconfig.txt";
}

</add before>

<edit file>
Admin/ManageTemplates.pm
</edit file>

<search for>
if (@managetemplatespmmods) {
</search for>

<add before>
push @managetemplatespmmods, 'Users Today';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($userstoday, $row_resize);
</add before>

<search for>
## End Mod Hook BoardIndex ##
</search for>

<add before>
## Start Users Today Mod ##
    require Sources::Mods::UsersToday;
    userstoday();
    $boardindex_template =~ s/\Q{yabb userstoday}\E/$userstoday/gxsm;
    $boardindex_template =~ s/\Q{yabb row_resize}\E/$row_resize/gxsm;
## End Users Today Mod ##
</add before>

<edit file>
Admin/AdminSubList.pm
</edit file>

<search for>
if (@adminsublistpmmods) {
</search for>

<add before>
push @adminsublistpmmods, 'Users Today';
</add before>

<search for>
1;
</search for>

<add before>
$director{'userstoday'} = 'Mods/UsersTodayAdmin.pm&UsersToday_Set'; ## Users Today Mod ##
$director{'userstoday2'} = 'Mods/UsersTodayAdmin.pm&UsersToday_Set2'; ## Users Today Mod ##

</add before>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
## Users Today Mod ##
    my $users_today_mod = q~Users Today|Brian Longo, Jeffrey Man (Jet Li) and Detlef Pilzecker (deti), updated to 2.7.00 by Dandello|Counts the number of members and guests that visit your board each day.  Counters are reset at midnight.  Also will log the number of users and guests to your board and is viewable through the Admin Center.  Original code by daicogra.|1.4|Mar 16, 2016~;
    push @installed_mods, $users_today_mod;
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
if (@englishadminlngmods) {
</search for>

<add before>
push @englishadminlngmods, 'Users Today';
</add before>

<search for>
1;
</search for>

<add before>
$mod_list{'userstoday_set'} = 'Users Today Settings';
$mod_list{'userstoday_set1'} = 'Edit your Users Today Settings';

</add before>

<edit file>
Sources/BoardIndex.pm
</edit file>

<search for>
if (@boardindexpmmods) {
</search for>

<add before>
push @boardindexpmmods, 'Users Today';
</add before>

<search for>
        if ($showlatestmember) {
            load_user($latestmember);
            my $latestmemberlink =
                qq~$boardindex_txt{'201'} ~
              . quick_links($latestmember)
              . q~.<br />~;
            $boardindex_template =~
              s/\Q{yabb latestmember}\E/$latestmemberlink/gxsm;
        }
        else {
            $boardindex_template =~ s/\Q{yabb latestmember}\E//gxsm;
        }
</search for>

<add after>
## Start Users Today Mod ##
        require Sources::Mods::UsersToday;
        userstoday();
## End Users Today Mod ##
</add after>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
if (@sublistpmmods) {
</search for>

<add before>
push @sublistpmmods, 'Users Today';
</add before>

<search for>
1;
</search for>

<add before>
$director{'showlog'} = 'Mods/UsersToday.pm&show_utlog';  # Users Today Mod #
</add before>

<edit file>
Templates/default/BoardIndex.template
</edit file>

<search for>
if (@defaultboardindexmods) {
</search for>

<add before>
push @defaultboardindexmods, 'Users Today';
</add before>

<search for>
                    {yabb groupcolors}
                    </div>
</search for>

<add after>
<!-- ## Start Users Today mod ## -->
{yabb userstoday}
<!-- ## End Users Today mod ## -->
</add after>

<search for>
1;
</search for>

<add before>
## Users Today ##
$myrow_resize = q~ rowspan="3"~;
$myuserstoday = q~<tr>
        <td class="catbg top" style="padding-left:1%">{yabb onlinetoday}</td>
      </tr>
      <tr>
          <td class="windowbg2 center top">
              <div class="small" style="float:left; width:100%; text-align:left;">{yabb gueststoday}{yabb myuserstoday}</div>
              <br /><span class="center">{yabb showplog}</span>
          </td>
    </tr>~;

</add before>